/*
  Java Japanese-English dictionary/Kanjidic browser
  Copyright (C) 1997 Todd David Rudick

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

 */

// Interface define filter functions
import java.util.*;
import GUI;

public interface Filter {
  public class romajiFilter implements Filter {
    Vector rom2KanaVector;
    public romajiFilter(Vector rom2KanaVector) {
      this.rom2KanaVector = rom2KanaVector;
    }
    String convert(String s) {
      String ret="";
      int i;
      while (s.length()>0) {
	int maxlen = -1;
	String maxmatch = s.substring(0,1);
	String maxkana = maxmatch;
	Enumeration e = rom2KanaVector.elements();
	while (e.hasMoreElements()) {
	GUI.RomKanaPair rk = (GUI.RomKanaPair) e.nextElement();
	  if ((s.startsWith(rk.kana))&&(rk.kana.length()>maxlen)) {
	    maxlen=rk.kana.length();
	    maxmatch=rk.romaji;
	    maxkana=rk.kana;
	  }
	}
	ret = ret + maxmatch;
	s = s.substring(maxkana.length());
      }
      /* now remove * and ' */
      int ind1 = ret.indexOf('\'');
      while (ind1!=-1) {
	ret=ret.substring(0,ind1)+ret.substring(ind1+1);
	ind1 = ret.indexOf('\'');
      }

      int ind2 = ret.indexOf('*');
      while (ind2!=-1) {
	if (ind2<ret.length()-1) {
	  ret=ret.substring(0,ind2)+ret.charAt(ind2+1)+ret.substring(ind2+1);
	} else {
	  ret=ret.substring(0,ind2)+'t'+ret.substring(ind2+1);
	}
	ind2 = ret.indexOf('*');
      }

      return(ret);
    }

    public String filter(String hit) {
      // convert all substrings of Jap chars that are maximal and don't
      // contain any kanji
      String retString="";
      
      while (hit.length()!=0) {
	if (hit.charAt(0)<256) { // it's not Japanese
	  retString=retString+hit.charAt(0);
	  hit=hit.substring(1);
	} else { // it's not Roman
	  int i;
	  boolean kanji = false;
	  for (i=1;((i<hit.length())&&(hit.charAt(i)>=256));i++) {
	    kanji=kanji||(hit.charAt(i)>'\u30FF');
	  }
	  if (kanji) {
	    retString=retString+hit.substring(0,i);
	  } else { // it's all kana
	    retString=retString+convert(hit.substring(0,i));
	  }
	  hit=hit.substring(i);
	} // end "it's not Roman"
      } //  "while hit.length!=0"
      return(retString);
      /*
      int beg, end;
      beg = hit.indexOf('[');
      end = hit.indexOf(']');
      if (beg==-1) {
	beg=0;
	end=hit.indexOf(' ');
	return(hit.substring(0,beg)+convert(hit.substring(beg,end))+
	       hit.substring(end));
      } else {
	beg++;
	return(convert(hit.substring(beg,end))+" "+hit.substring(0,beg-1)+
	       hit.substring(end+1));
      }*/
    }
  }
  public abstract String filter(String hit);
}
