/*
  Java Japanese-English dictionary/Kanjidic browser
  Copyright (C) 1997 Todd David Rudick

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

 */

import JavaDict;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import ClearState;

public class OptionGUI extends Panel implements ActionListener {
  JavaDict javadict;
  Checkbox romajiCheckbox;
  Vector clearStates = new Vector();

  public void addClearState(ClearState cs) {
    clearStates.addElement(cs);
  }

  public void actionPerformed(ActionEvent ae) {
    Enumeration e = clearStates.elements();
    while (e.hasMoreElements()) {
      ((ClearState)e.nextElement()).clearState();
    }
  }

  public boolean getRomajiFlag() {
    //    System.out.println("Romaji flag is "+romajiCheckbox.getState());
    return(romajiCheckbox.getState());
  }
  
  public OptionGUI(JavaDict javadict,Button MenuButton) {
    super();

    MenuButton.addActionListener(this);

    this.javadict = javadict;
    setLayout(new BorderLayout());
    Panel p = new Panel(new BorderLayout());
    add(p,"South");
    Panel p2 = new Panel();
    p.add(p2,"East");
    p2.add(MenuButton);
    Panel p3 = new Panel(new FlowLayout(FlowLayout.LEFT));
    add(p3,"Center");
    Panel p4 = new Panel(new GridLayout(3,1));
    p3.add(p4);
    p4.add(new Label("Display readings in"));
    CheckboxGroup cbg = new CheckboxGroup();
    romajiCheckbox = new Checkbox("Roman letters",cbg,false);
    p4.add(romajiCheckbox);
    p4.add(new Checkbox("Japanese Kana",cbg,true));
  }
}
